#include "stdafx.h"

class Vector
{
public:

	int Sum(int a, int b);

	int Pro(int a, int b);
};

// Vector::Sum means that "Sum belongs to Vector"
// the operator :: is called name resolution operator
// or scope resolution operator.


int Vector::Sum(int a, int b)
{
	return a + b;
}

// Vector::Pro means that "Pro belongs to Vector"
// :: symbol or operator is called name resolution operator
// of is called the scope resolution operator
int Vector::Pro(int a, int b)
{
	return a * b;
}

void StartTest()
{
	// member function pointer variable declation
	int (Vector::*pMemFuncPtr)(int, int);

	// we can assign member function to 
	// member function pointer
	pMemFuncPtr = &Vector::Sum;

	Vector v;

	// member function call using member function pointer
	(v.*pMemFuncPtr)(1, 2);

	pMemFuncPtr = &Vector::Pro;

	(v.*pMemFuncPtr)(3, 4);

}